poj 3463(次短路径)

来源:互联网 发布:淘宝上的主板能买吗 编辑:程序博客网 时间:2024/06/05 10:32
Sightseeing
Time Limit: 2000MS Memory Limit: 65536KTotal Submissions: 8094 Accepted: 2873

Description

Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.

There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.

For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

Input

The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

  • One line with two integers N and M, separated by a single space, with 2 ≤ N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.

  • M lines, each with three integers AB and L, separated by single spaces, with 1 ≤ AB ≤ NA ≠ B and 1 ≤ L ≤ 1,000, describing a road from city A to city B with length L.

    The roads are unidirectional. Hence, if there is a road from A to B, then there is not necessarily also a road from B to A. There may be different roads from a city A to a city B.

  • One line with two integers S and F, separated by a single space, with 1 ≤ SF ≤ N and S ≠ F: the starting city and the final city of the route.

    There will be at least one route from S to F.

Output

For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 109 = 1,000,000,000.

Sample Input

25 81 2 31 3 21 4 52 3 12 5 33 4 23 5 44 5 31 55 62 3 13 2 13 1 104 5 25 2 75 2 74 1

Sample Output

32

Hint

The first test case above corresponds to the picture in the problem description.


解题思路:

对于长度仅为最短路+1的路,处理时我们可以放宽一些限制;

只需求最短路和次短路,然后判断一下次短路是否满足情况就好了;

那么,求最短路+次短路的算法就用dij来处理;

令:

dis[x][k]表示x点的最短路次短路长度;

cnt[x][k]表示x点的最短路次短路分别的种类数;

vis[x][k]表示在dij算法中已经固定了的点,不会再次被更新;

k∈{0,1},分别表示最短路和次短路;

然后每次找出所以路中最小的一个,更新所有可到达的点;

分情况讨论累计种类数,就可以得到答案了;


HINT:

1.实际上dij时因为n较小,用heap实现也是可以的,但是代码比较麻烦,所以直接枚举O(n^2)

2.至于用dij而不用spfa是因为dij算法每个结点只会对其它结点进行一次更新;

   spfa可能多次入队多次更新造成计数错误,但是记录一些东西也是可以做的;

3.dij的循环要执行2*n次因为有2*n个vis数组要更新;



AC:

#include<vector>#include<stdio.h>#include<string.h>#include<algorithm>#define N 1100using namespace std;vector<int>to[N], val[N];int dis[N][2], cnt[N][2];int vis[N][2];void init(int n){for (int i = 1; i <= n; i++)to[i].clear(),val[i].clear();memset(vis, 0, sizeof(vis));memset(cnt, 0, sizeof(cnt));memset(dis, 0x3f, sizeof(dis));}void Dij(int n){int s, t, i, j, k, x, y;bool fl;scanf("%d%d", &s, &t);dis[s][0] = 0;cnt[s][0] = 1;for (i = 1; i <= 2 * n; i++){k = 0x3f3f3f3f;for (j = 1; j <= n; j++){if (!vis[j][0] && dis[j][0] < k)x = j, fl = 0, k = dis[j][0];else if (!vis[j][1] && dis[j][1] < k)x = j, fl = 1, k = dis[j][1];}if (k == 0x3f3f3f3f)break;vis[x][fl] = 1;for (j = 0; j < to[x].size(); j++){y = to[x][j];if (dis[y][0]>k + val[x][j]){dis[y][1] = dis[y][0], cnt[y][1] = cnt[y][0];dis[y][0] = k + val[x][j], cnt[y][0] = cnt[x][fl];}else if (dis[y][0] == k + val[x][j])cnt[y][0] += cnt[x][fl];else if (dis[y][1] > k + val[x][j])dis[y][1] = k + val[x][j], cnt[y][1] = cnt[x][fl];else if (dis[y][1] == k + val[x][j])cnt[y][1] += cnt[x][fl];}}if (dis[t][1] == dis[t][0] + 1)cnt[t][0] += cnt[t][1];printf("%d\n", cnt[t][0]);}int main(){int c, T, n, m, i, j, k, x, y, v;scanf("%d", &T);for (c = 1; c <= T; c++){scanf("%d%d", &n, &m);init(n);for (i = 1; i <= m; i++){scanf("%d%d%d", &x, &y, &v);to[x].push_back(y);val[x].push_back(v);}Dij(n);}return 0;}


0 0
原创粉丝点击